#ifndef _2001LANDMOD_H_
#define _2001LANDMOD_H_

#include <cstdio>
#include "../../include/cvel.h"

const VECTOR3 OFS_SEAT = _V(0,-0.4,5.0);
const double MAX_GRAPPLING_DIST = 2.0;

//#define MAXLOAD 50
/*
typedef struct {
	double mass;
	double fuel;
	double rot;
	char name[80];
	char meshname[80];
	char plclass[80];
	bool stage;
	MESHHANDLE h_msh_pl;
	bool attached;
	VECTOR3 v;
	UINT msh_pl;
} PAYLOAD;
*/
class LANDMOD: public COMMON_VESSEL_EX 
{
public:
	LANDMOD (OBJHANDLE hObj, int fmodel );

	enum DoorStatus { DOOR_CLOSED, DOOR_OPEN, DOOR_CLOSING, DOOR_OPENING } expand_status, box_status, drogue_status, chute_status, deflate_status;

	void LoadState (FILEHANDLE scn, void *vs);
	void SaveState (FILEHANDLE scn);
//	void SetDefSuit();
	void SetStage ();
	void SetAnims ();
	void SetClassCaps (FILEHANDLE cfg);
	void TimeStep( double simt );
	void SetNewStage();
	void StrapUnstrap();
	int  ConsumeBufferedKey ( DWORD dwKey, bool fPressed, const char *keystate);
	int  ConsumeKey ( const char *keystate);
	double EXPAND_SPEED, DEFLATE_SPEED;
	double expand_proc, box_proc, drogue_proc, chute_proc, deflate_proc;
	int numevas;
	bool Expanding, Burning, RetroDefined, defaultsuit;
	double pay_mass;
//	PAYLOAD load[MAXLOAD];

// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);
	void clbkVisualCreated (VISHANDLE vis, int refcount);
	void clbkVisualDestroyed (VISHANDLE vis, int refcount);

protected :
	PROPELLANT_HANDLE ph_main;
	THRUSTER_HANDLE th_main[3];
	THRUSTER_HANDLE eject_engine[4];
	THRUSTER_HANDLE th_hover[4];

	THGROUP_HANDLE thg_main;
	THGROUP_HANDLE thg_retro;
	THGROUP_HANDLE thg_eject;
	THGROUP_HANDLE thg_hover;
	MESHHANDLE  hCone;
	SURFHANDLE  tex, retex;
	DOCKHANDLE dock0, dock1, dock2, dock3;
	char payloadmesh[256];
	UINT anim_expand, anim_box, anim_drogue, anim_chute, anim_deflate;
	VESSEL *depV;
	OBJHANDLE hVessel;
	bool banimsset;
	double RCSMass;
	ATTACHMENTHANDLE Seatpos;
	int stage;
	double dragset;
	double RetroThrust;
	VESSELSTATUS vs;
	double drymass, xscale, yscale, zscale;

};


#endif
