#if !defined(___GENERIC_ASTRONAUT_HPP___)
#define ___GENERIC_ASTRONAUT_HPP___

#include "../../include/orbitersdk.h"
#include "../../include/OrbiterSoundSDK3.h"
#include <math.h>

//const double TETHER_OPERATING_SPEED = 0.128;
//const double TETHER_MAX_ANGLE = RAD*90.0;
const double MAX_GRAPPLING_DIST = 1.0;
const double MAX_RETURN_DIST = 10.0;
//const VECTOR3 OFS_SEAT = _V(0,0.2,0);
//const VECTOR3 OFS_LHAND = _V(-0.26,0.0,0.28);
//const VECTOR3 OFS_RHAND = _V( 0.26,0.0,0.28);
const double maxheight = 2.0;
const double minheight = 0.95;
//const double EMPTY_MASS = 110.0;
//const double PROPELLANT_MASS = 10.0;
const double TURN_SPEED = 100.0 * RAD;
const double WALKING_SPEED = 130.0 / 5.0;

const double MAX_WEIGHTFORCE = 25000000.0;

//   CBT:RPG inspired astronaut stats.
//	unsigned short usBOD;
//	unsigned short usSTR;
//	unsigned short usDEX;
//	unsigned short usRFL;
//	unsigned short usINT;
//	unsigned short usWIL;
//	unsigned short usCHA;
//	unsigned short usEDG;
//	unsigned short usSOC;



class GENERIC_EVA: public VESSEL2
{

	PROPELLANT_HANDLE phRCS;
	THRUSTER_HANDLE thRCS[12+8];

	double fOxygen;
	bool OnInit;
	OBJHANDLE gvessel, hV;
	ATTACHMENTHANDLE Seat, LHand, RHand, hAtt;
	MESHHANDLE		  hgemini_leva;
	bool higher;
	double height;
//	double simdt, lastt, simt;
//	VESSELSTATUS vs;
//	VESSELSTATUS eva;
	VECTOR3 gpos, grms, pos, dir, rot;
	bool KEY1, KEY2, KEY3, KEY4, KEY5, KEY6, KEY7, KEY8, KEY9;
	bool bHandArmed;
	bool bDisplayAttachments;
	bool bUseNumPad;
	VECTOR3 OFS_SEAT, OFS_LHAND, OFS_RHAND;

	int MyID;
	double LHandMass, RHandMass;

	double THRUST_ATT_VAC;
	double PROP_MASS; 
	double DRYMASS;
	double ISP_FIRST_VAC;

	void boardVessel();

	void createRCS();

	void drawAttachments(const HUDPAINTSPEC* hps, HDC hdc);
	void moveEVA(double fSimT, double fDeltaT, double fMJD);

	void takeObjectLeft();
	void takeObjectRight();
public:
	GENERIC_EVA(OBJHANDLE hVessel, int iFlightModel);
	virtual ~GENERIC_EVA();
	int clbkConsumeBufferedKey(DWORD dwKey, bool fPressed, char* keymap);
	int clbkConsumeDirectKey(char* keymap);
	void clbkDrawHUD(int mode, const HUDPAINTSPEC* hps, HDC hdc);
	void clbkLoadStateEx(FILEHANDLE scn, void *vs);
	void clbkPreStep(double fSimT, double fDeltaT, double fMJD);
	void clbkPostStep(double fSimT, double fDeltaT, double fMJD);
	void clbkSetClassCaps(FILEHANDLE cfg);
	void ResetClassCaps();
	void clbkSaveState(FILEHANDLE scn);
	void MakeADummy();

};

#endif