/**
*
* $Id: RocketBus.cpp
* (c) 2005 Sputnik -- erik_h_anderson@hotmail.com
* Based on CVEL Centaur-G code
* Ervins Reinverts -- ervins@gmail.com
* Based on CVEL Fregat code
* (c) 2004 David Henderson -- orbiter@aibs.org.uk
* Licence LGPL -- http://www.gnu.org/licenses/lgpl.txt
*
* You may use this source code in your addon provided that if you
* publish your addon either privately or publicly the end user
* recieves a copy of the source code including any modifications
* you may have made. 
*
*/

#include "RocketBus.h"

ROCKETBUS::ROCKETBUS (OBJHANDLE hObj, int fmodel)
: COMMON_VESSEL_EX (hObj)
//: VESSEL2 (hObj)
{
	hRocketBus = oapiLoadMeshGlobal ("2001/RocketBus");
	tex = oapiRegisterExhaustTexture("Exhaust_atsme");

	/* set the propellant handle to NULL so I can check if I need to 
	/* create it in the SetMainStage() function. */
	ph_first=NULL; 
	simt = 0;
	simdt = 0.1;
	lastt = 0;
	hatch_status=DOOR_CLOSED;
	hatch_proc=0.0;
	anim_hatch = 0.0;
	CreateDock (_V(0,2.525,-8.00), _V(0,0,-1), _V(0,1,0));


/*
	static UINT HatchGrp[1] = {39};
	static MGROUP_ROTATE Hatch (0, HatchGrp, 1,
		_V(0.0,-0.28,-5.58), _V(1,0,0), (float)(-180*RAD));
	anim_hatch = CreateAnimation(0);
	AddAnimationComponent (anim_hatch, 0.05, 0.95, &Hatch);
*/
	MyID=ConnectToOrbiterSoundDLL3(GetHandle());

	RequestLoadVesselWave3(MyID,MYRADARSOUND,"Sound\\2001\\rusbeep.wav",INTERNAL_ONLY);
	RequestLoadVesselWave3(MyID,MYRADARCLOSE,"Sound\\2001\\rusclose.wav",INTERNAL_ONLY);
	SoundOptionOnOff3(MyID,PLAYRADARBIP,FALSE);

//	RequestLoadVesselWave3(MyID,PLAYTREADS,"Sound\\2001\\treads.wav",BOTHVIEW_FADED_FAR);


	/* CVE-lite function ! */
	/* IMPORTANT */
	/* This function loops through the pending GDPS requests. Have it run
	/* in the constructor so it can set up things like the InitFuelLevel
	/* (initial fuel level) variable, and load the payloads */
	CheckCentralMessage();   
}


ROCKETBUS::~ROCKETBUS()
{

}


void ROCKETBUS::RussianBeeps()
{
		double Altitude=0;
		double Distance=1000;
		oapiGetFocusAltitude(&Altitude);
		Local2Global (_V(0,0,0), grms);  // global position of RMS tip
		for (int i = 0; i < oapiGetVesselCount(); i++) {
			hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to check ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (((dist (gpos, grms) - oapiGetSize(hV) - oapiGetSize(GetHandle())) < Distance) && ((dist (gpos, grms) - oapiGetSize(hV) - oapiGetSize(GetHandle())) > 10.0))
				Distance = dist(gpos,grms) - oapiGetSize(GetHandle());
		}
		if ((Distance < Altitude) || (Altitude == 0))
			Altitude = Distance;			// Play beeps based on object distance instead!



		// ------------------------------------------------------
		// here we play our radar sound that slide with altitude
		// ------------------------------------------------------
		if(Altitude<600&&Altitude>25)
		{
			PlayVesselWave3(MyID,MYRADARSOUND,LOOP,255,(int)(16000+((600-Altitude)*10)));		// play looped and a frequency that increase with altitude
			RadarFlagForSound=TRUE;
			if(RadarFlagForClose=TRUE)
			{
				// we stop the sound only once (it would not harm else but it will save a bit of processor time)
				StopVesselWave3(MyID,MYRADARCLOSE);
				RadarFlagForClose = FALSE;
			}
		}
		else if (Altitude<25&&Altitude>10) 
		{
			PlayVesselWave3(MyID,MYRADARCLOSE,LOOP,255);		// play looped 
			RadarFlagForClose=TRUE;
			if(RadarFlagForSound=TRUE)
			{
				// we stop the sound only once (it would not harm else but it will save a bit of processor time)
				StopVesselWave3(MyID,MYRADARSOUND);
				RadarFlagForSound = FALSE;
			}
		}
		else {
			if(RadarFlagForSound=TRUE)
			{
				// we stop the sound only once (it would not harm else but it will save a bit of processor time)
				StopVesselWave3(MyID,MYRADARSOUND);
				RadarFlagForSound = FALSE;
			}
			if(RadarFlagForClose=TRUE)
			{
				// we stop the sound only once (it would not harm else but it will save a bit of processor time)
				StopVesselWave3(MyID,MYRADARCLOSE);
				RadarFlagForClose = FALSE;
			}
		}
}

void ROCKETBUS::TimeStep(  double simt )
{
	/* CVE-lite function ! */
	/* IMPORTANT */
	/* This function loops through the pending GPDS requests and returns a bool (true/false)
	/* if any GPDS requests have been implemented.
	/* If any have (eg adding a new payload), you will need to re-draw your ship, hence the
	/* call to the (repeatable) SetMainStage(); */
	if( CheckCentralMessage() )
		SetMainStage();

	RussianBeeps();
//	UpdateAnimations();

	simdt = simt-lastt;
	lastt=simt;

//	if (vs.status == 1)
//		if (KEY1 || KEY2 || KEY3 || KEY4 || KEY5 || KEY6 || KEY7 || KEY8 || KEY9) 
//			MoveEVA();
}



void ROCKETBUS::MoveEVA()

// MoveEVA code shamelessly borrowed from the NASSP code.  Thanks to whoever invented this!

{
	double cm ;
//	double lat;
//	double lon;
//	double cap;
	double timeW=1;

	VESSELSTATUS2 vs;
//	VESSELSTATUS2::FUELSPEC fuel;
//	VESSELSTATUS2::THRUSTSPEC thrust;
	memset (&vs, 0, sizeof(vs));
	vs.base=NULL;
	vs.version = 2;

	GetStatusEx(&vs);
	vs.base=NULL;

//	if (vs.status != 1) return;
//	oapiGetHeading(GetHandle(),&cap);
	timeW=oapiGetTimeAcceleration();
	if (timeW >100)
		oapiSetTimeAcceleration(100);
//	lon = vs.surf_lng;
//	lat = vs.surf_lat;
//	cap = vs.surf_hdg;
//	lon=vs.vdata[0].x;
//	lat=vs.vdata[0].y;
//	if (Astro){
//		cm = 0.86e-7*timeW;
		cm = 7.86e-6*simdt*timeW;
//		PlayVesselWave(HAstro,LOOP,135);
//	}else{
//		PlayVesselWave(HRover,LOOP,245);
//		cm = 1.36e-7*timeW;
//	}
	if (KEY1){
		vs.surf_hdg = vs.surf_hdg - 1.25*PI*0.5/180;
		if(!IsPlaying3(MyID,PLAYTREADS))
			PlayVesselWave3(MyID,PLAYTREADS);
//		StopVesselWave(HAstro);
		if(vs.surf_hdg <=-2*PI){
			vs.surf_hdg = vs.surf_hdg + 2*PI;
		}
		KEY1=false;
	}
	else if (KEY3){
		vs.surf_hdg = vs.surf_hdg +(1.25*PI*0.5/180);
		if(!IsPlaying3(MyID,PLAYTREADS))
			PlayVesselWave3(MyID,PLAYTREADS);
//		StopVesselWave(HAstro);
		if(vs.surf_hdg >=2*PI){
			vs.surf_hdg = vs.surf_hdg - 2*PI;
		}
		KEY3=false;
	}
	else if (KEY2){
		if(!IsPlaying3(MyID,PLAYTREADS))
			PlayVesselWave3(MyID,PLAYTREADS);
		vs.surf_lat = vs.surf_lat - cos(vs.surf_hdg) * cm;
		vs.surf_lng = vs.surf_lng - sin(vs.surf_hdg) * cm;
		KEY2=false;
	}
	else if (KEY4 ){
//		vs.surf_lat = vs.surf_lat + sin(vs.surf_hdg) * 0.25*cm;
//		vs.surf_lng = vs.surf_lng - cos(vs.surf_hdg) * 0.25*cm;
		KEY4=false;
	}
	else if (KEY5){
		KEY5=false;
	}
	else if (KEY6 ){
//		vs.surf_lat = vs.surf_lat - sin(vs.surf_hdg) * 0.25*cm;
//		vs.surf_lng = vs.surf_lng + cos(vs.surf_hdg) * 0.25*cm;
		KEY6=false;
	}
	else if (KEY7){
		KEY7=false;
	}
//	else if (KEY8||GoHover && !Astro){// we go ahead whatever our headign
	else if (KEY8){// we go ahead whatever our headign
		if(!IsPlaying3(MyID,PLAYTREADS))
			PlayVesselWave3(MyID,PLAYTREADS);
		vs.surf_lat = vs.surf_lat + cos(vs.surf_hdg) * cm;
		vs.surf_lng = vs.surf_lng + sin(vs.surf_hdg) * cm;
		KEY8=false;
	}
	else if (KEY9){
		KEY9=false;
	}else{		
		StopVesselWave3(MyID,PLAYTREADS);
//		StopVesselWave(HAstro);
//		StopVesselWave(HRover);
	}

//	vs.vdata[0].x=lon;
//	vs.vdata[0].y=lat;
//	vs.surf_lng = lon;
//	vs.surf_lat = lat;
//	vs.surf_hdg = cap;

//	vs.surf_lng = 0.0;
//	vs.status = 0;
//	vs.rpos.x=23000000.0;

	vs.version = 2;

	KEY8 = false;
	DefSetStateEx(&vs);
}


void ROCKETBUS::UpdateAnimations()
{	

	// animate aft hatch
	if (hatch_status >= DOOR_CLOSING) {
		double da = oapiGetSimStep() * HATCH_OPERATING_SPEED;
		if (hatch_status == DOOR_CLOSING) {
			if (hatch_proc > 0.0)
				hatch_proc = max (0.0, hatch_proc-da);
			else {
				hatch_status = DOOR_CLOSED;
			}
		} else  { // door opening
			if (hatch_proc < 1.0)
				hatch_proc = min (1.0, hatch_proc+da);
			else {
				hatch_status = DOOR_OPEN;
			}
		}
		SetAnimation (anim_hatch, hatch_proc);
	}

}

void ROCKETBUS::ActivateHatch (DoorStatus action)
{
	hatch_status = action;
}

void ROCKETBUS::RevertHatch ()
{
	ActivateHatch (hatch_status == DOOR_CLOSED || hatch_status == DOOR_CLOSING ?
						 DOOR_OPENING : DOOR_CLOSING);
}


void ROCKETBUS::SeparateEVA ()
{
	VESSELSTATUS vs;
	GetStatus (vs);
	vs.eng_main = vs.eng_hovr = 0.0;
	vs.fuel=1.0;
//	if (GetGravityRef() != GetSurfaceRef())				// I.E., Phobos
		vs.status = 0;
///	vs.status=0;
	VECTOR3 ofs = EVA_OFS;
	Local2Rel (ofs, vs.rpos);
	char name[256], name2[256];
//	strcpy (name, GetName()); strcat (name, "-PLT");


	UINT i;
	for (i=1;i<9;i++) {
			strcpy (name2, GetName()); 
			sprintf(name, "-EV%d", i);
			strcat (name2, name);
			hvessel=oapiGetVesselByName(name2);
			if (hvessel == 0) break;
	}		
	if ( i < 8) 
	{
		VESSEL::Create (name2, "2001/Astro2001", vs);
		hvessel=oapiGetVesselByName(name2);
		oapiSetFocusObject(hvessel);
	}

}



/* CVE-lite function ! */
/* IMPORTANT */
/* VisualCreated() is a function passed through from CVE-lite as a direct replacement
/* for the DLLCLBK ovcVisualCreated() function.
/* You can't use ovcVisualCreated() with CVE-lite, so use this instead! */

void ROCKETBUS::VisualCreated ( VESSEL *vessel, VISHANDLE vis, int refcount) {
	/* local equivalent to the DLLCLBK ovcVisualCreated() */
	SetMainStage(); // this is a good place to ask for the initial setup.
}


void ROCKETBUS::SetClassCaps(  FILEHANDLE cfg )
{
	/* ensure the propellent handle is set to NULL before creation */
	ph_first=NULL;
	SetMainStage();
}

void ROCKETBUS::SaveState( FILEHANDLE scn )
{
	char cbuf[256];

	SaveDefaultState (scn);
	sprintf (cbuf, "%d %0.4f", hatch_status, hatch_proc);
	oapiWriteScenario_string (scn, "HATCH", cbuf);
	/* save payload lines */
	SaveDefaultStateEx(scn);

}

void ROCKETBUS::LoadState(  FILEHANDLE scn, void *vs )
{
    char *line;

	while (oapiReadScenario_nextline (scn, line)) 
	{
		/* CVE-lite function ! */
		/* IMPORTANT */
		/* Call this for every line in the scenario file. It will automatically
		/* deduce which lines are for it, and load the payloads from the file. */

		/* load payload lines */
		if (!strnicmp (line, "HATCH", 5)) {
		sscanf (line+5, "%d%lf", &hatch_status, &hatch_proc);
		} 
		else ParsePayloadString(line);

		ParseScenarioLineEx (line, vs);
	}

	/* always set the stage whenever something may have changed */
	SetMainStage();
	RevertHatch();
	RevertHatch();

}

/* IMPORTANT */
/* Always have a function that you can call as many times as you like that will re-draw
/* all you meshes, reset all your thrusters and check to make sure the propellent is
/* there. This should be called after any configuration change, or any GDPS line (see
/* TimeStep(), above) */

void ROCKETBUS::SetMainStage( )
{

	const VECTOR3 VECTOR_ZERO = _V(0,0,0);

	/* CVE-lite function ! */
	/* ClearMeshesEx() will get rid of all the normal meshes, plus anything you've defined
	/* with the COMMON_MESH class (not used here) */

	/* erase all meshes and thrusters so we can start afresh */
	ClearMeshesEx();
	ClearThrusterDefinitions();

	PARTICLESTREAMSPEC contrail = 
	{
		0, 25.0, 7, 350, 0.3, 4.0, 7, 3.0, PARTICLESTREAMSPEC::DIFFUSE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-4, 1
	};

	PARTICLESTREAMSPEC exhaust_main = {
		0, 3, 25, 350, 0.1, 0.2, 28, 1.0, PARTICLESTREAMSPEC::EMISSIVE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-5, 0.1
	};
	exhaust_main.tex = oapiRegisterParticleTexture ("Contrail2");
	SetSize (15);

	/* CVE-lite function ! */
	/* IMPORTANT */
	/* double CalculateMass() will return the all-up mass of the combined payloads and
	/* upper stages. Simply add this to your normal dry mass. */
	
	/* always add payload mass [CalculateMass()] to the vessel's empty mass */
	SetEmptyMass ( ROCKETBUS_DRYMASS + CalculateMass());

	SetTouchdownPoints(_V(0,-6,9),_V(-4,-6,-5),_V(4,-6,-5));
	SetPMI (_V(17,17,14.5));
	SetCrossSections (_V(4,4,2.5));
	SetCW (0.1, 0.3, 1.4, 1.4);
	SetRotDrag (_V(0.7,0.7,1.2));
	SetPitchMomentScale (1e-6);
	SetBankMomentScale (1e-6);
	SetLiftCoeffFunc (0); 
	SetCameraOffset(_V(-0.6,0.5,4.6));


	/* we're not using COMMON_MESH today, so draw our own */
	AddMesh(hRocketBus, &VECTOR_ZERO );
//	SetMeshVisibilityMode(0,MESHVIS_ALWAYS);
	
	/* CVE-lite function ! */
	/* IMPORTANT */
	/* Draw() should be called to render all the loaded payloads, plus anything you've
	/* added with the COMMON_MESH class (not used here) */

	/* call draw to render the payloads, plus anything you've added from COMMON_MESH */
	Draw();

	/* CVE-lite variable ! */
	/* IMPORTANT */
	/* Use the keyword double InitFuelLevel multipled by the maximum mass to have the
	/* fuel levels automatically set from the GPDS payload string */

	/* verify that the propellent hasn't been created before making it */
	if (ph_first==NULL)  
		ph_first  = CreatePropellantResource(FIRST_PROP_MASS,FIRST_PROP_MASS*InitFuelLevel,1.0); 


	SetDefaultPropellantResource (ph_first); 

	th_first[0] = CreateThruster ( _V(0,-2.3,3), _V( 0,1,0), THRUST_FIRST_VAC, ph_first, ISP_FIRST_VAC, ISP_FIRST_SL);
//	AddExhaustStream (th_first[0], _V(0.72,0,-7), &contrail);
//	AddExhaustStream (th_first[0], _V(0.72,0,-7), &exhaust_main);

	th_first[1] = CreateThruster ( _V(0,-1.8,0), _V(0,1,0), THRUST_FIRST_VAC, ph_first, ISP_FIRST_VAC, ISP_FIRST_SL);
//	AddExhaustStream (th_first[1], _V(-0.72,0,-7), &contrail);
//	AddExhaustStream (th_first[1], _V(-0.72,0,-7), &exhaust_main);

	th_first[2] = CreateThruster ( _V(0,-3,-3), _V( 0,1,0), THRUST_FIRST_VAC, ph_first, ISP_FIRST_VAC, ISP_FIRST_SL);
//	AddExhaustStream (th_first[0], _V(0.72,0,-7), &contrail);
//	AddExhaustStream (th_first[0], _V(0.72,0,-7), &exhaust_main);

	thg_first = CreateThrusterGroup (th_first, 3, THGROUP_HOVER);
	
	AddExhaust (th_first[0], 6.0, 0.8, _V(0,-2.3,2.7), _V( 0,-1,0), tex);
	AddExhaust (th_first[1], 6.0, 0.8, _V(0,-1.8,-1.3), _V(0,-1,0), tex);
	AddExhaust (th_first[2], 6.0, 0.8, _V(0,-3,-6.2), _V( 0,-1,0), tex);

	th_fwd[0] = CreateThruster ( _V( 1.6,0,-8.5), _V( 0,0,1), THRUST_FIRST_VAC*0.7, ph_first, ISP_FIRST_VAC, ISP_FIRST_SL);
	th_fwd[1] = CreateThruster ( _V(-1.6,0,-8.5), _V( 0,0,1), THRUST_FIRST_VAC*0.7, ph_first, ISP_FIRST_VAC, ISP_FIRST_SL);


	AddExhaust (th_fwd[0], 6.0, 0.8, tex);
	AddExhaust (th_fwd[1], 6.0, 0.8, tex);

	thg_fwd = CreateThrusterGroup (th_fwd, 2, THGROUP_MAIN);

	SetAttControlsRocketBus();
	EnableTransponder(true);
}





/** Handle buffered key events sent to the vessel by orbiter. 
 *  @param dwKey The scan code of the key
 *  @param fPressed true if pressed, false if depressed
 *  @param keystate the current state of the keyboard
 *
 *  modified switch routine by dave rowbotham.
 */


int ROCKETBUS::ConsumeBufferedKey(DWORD dwKey, bool fPressed, const char *keystate)
{
	if (!fPressed) return 0; // only process keydown events
	if (KEYMOD_SHIFT (keystate)) 
	{
	}
	else if (KEYMOD_CONTROL (keystate)) 
	{
		// insert ctrl key combinations here
	}
	else {

		if (KEYDOWN (keystate, OAPI_KEY_J)) 
		{ // "Jettison Stage"
			if (oapiAcceptDelayedKey (OAPI_KEY_J, 1.0))
			{

			/* CVE-lite function ! */
			/* IMPORTANT */
			/* call DeployPayload() to jettison the GPDS payloads in sequence */

				DeployPayload();

			/* IMPORTANT */
			/* Always re-set the stage after any kind of change */
				SetMainStage();
			}
			return 1;
		}
		if (KEYDOWN (keystate, OAPI_KEY_P)) 
		{ // Toggle the top hatch / airlock
			if (oapiAcceptDelayedKey (OAPI_KEY_P, 1.0))
			{
				RevertHatch ();
			}
			return 1;
		}
		if (KEYDOWN (keystate, OAPI_KEY_E)) 
		{ 
			if (oapiAcceptDelayedKey (OAPI_KEY_E, 1.0))
				{
//				if (hatch_status == DOOR_OPEN)
//					{
							SeparateEVA();
							SetMainStage();
//					}
			}
		return 1;
		}
	}
	return 0;
}


int ROCKETBUS::ConsumeKey (const char *keystate)
{

	if (KEYDOWN(keystate, OAPI_KEY_1) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY1 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_2) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY2 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_3) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY3 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_4) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY4 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_5) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY5 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_6) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY6 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_7) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY7 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_8) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY8 = true;
	}
	else if (KEYDOWN(keystate, OAPI_KEY_9) && !KEYMOD_CONTROL(keystate) && !KEYMOD_SHIFT(keystate) ) // "Walk Right" 
	{
		KEY9 = true;
	}
	return 0;
}

/*
int ROCKETBUS::ConsumeKey( const char *keystate )
{

	if (KEYMOD_SHIFT (keystate)) 
	{
						
		return 0; // shift combinations are reserved
	}
	else if (KEYMOD_CONTROL (keystate)) 
	{
		return 0;
	}
	else 
	{ // unmodified keys
	
		return 0;

	}
	return 0;
}

*/


void ROCKETBUS::SetAttControlsRocketBus()
{
	THRUSTER_HANDLE th_rot[2];
	th_rot[0] = CreateThruster (_V(0,0, 5), _V(0, 1,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,0,-5), _V(0,-1,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);

	thg_pitchup=CreateThrusterGroup (th_rot, 2, THGROUP_ATT_PITCHUP);

	th_rot[0] = CreateThruster (_V(0,-0.2,-5.25), _V(0,1,0),MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,-0.75,5.25), _V(0,1,0),MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_UP);
	th_rot[0] = CreateThruster (_V(0,-0.2,-5.25), _V(0,-1,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,-0.75,5.25), _V(0,-1,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_DOWN);

	th_rot[0] = CreateThruster (_V(0,0, 5), _V(0,-1,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,0,-5), _V(0, 1,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);

	thg_pitchdown=CreateThrusterGroup (th_rot, 2, THGROUP_ATT_PITCHDOWN);

	th_rot[0] = CreateThruster (_V(0,0, 4), _V(-1,0,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,0,-4), _V( 1,0,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);

	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_YAWLEFT);

	th_rot[0] = CreateThruster (_V(0,0, 4), _V( 1,0,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(0,0,-4), _V(-1,0,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);

	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_YAWRIGHT);

	th_rot[0] = CreateThruster (_V(2,0.0,0.0), _V(-1,0,0), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_LEFT);
	th_rot[0] = CreateThruster (_V(2,0.0,0.0), _V(1,0,0),MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_RIGHT);

	th_rot[0] = CreateThruster (_V(4,0,0), _V(0,-1,0), MAX_ATT_FIRST/2, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(-4,0,0), _V(0, 1,0), MAX_ATT_FIRST/2, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_BANKRIGHT);

	th_rot[0] = CreateThruster (_V(4,0, 0), _V(0, 1,0), MAX_ATT_FIRST/2, ph_first, ISP_FIRST_SL);
	th_rot[1] = CreateThruster (_V(-4,0,0), _V(0, -1,0), MAX_ATT_FIRST/2, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 2, THGROUP_ATT_BANKLEFT);

	th_rot[0] = CreateThruster (_V(0,0, -4), _V(0,0,1), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_FORWARD);
	th_rot[0] = CreateThruster (_V(0,0, 4), _V(0,0,-1), MAX_ATT_FIRST, ph_first, ISP_FIRST_SL);
	CreateThrusterGroup (th_rot, 1, THGROUP_ATT_BACK);
}
